#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXWIDTH	640
#define	MAXHEIGHT	200

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		pixel[MAXWIDTH][MAXHEIGHT];

	int		width,height;
	int		x,y,col;
	int		c,i,sft;
	int		a0,a1,a2,a3;

	if (argc != 3) {
		fprintf(stderr, "Usage: convpict infile outfile \n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	a0 = fgetc(infp);
	a1 = fgetc(infp);
	a2 = fgetc(infp);
	a3 = fgetc(infp);

	fputc(a0,outfp);
	fputc(a1,outfp);
	fputc(a2,outfp);
	fputc(a3,outfp);

	width  = (a0 + a1*256);
	height = (a2 + a3*256);



	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x ++) {
			pixel[x][y] = 0x08;
		}
	}

/* f[^ǂݍ */
	for (y = 0;y < height;y ++) {
		for (col = 0x01;col < 0x08;col *= 2) {
			for (x = 0;x < width;x += 8) {
				c = fgetc(infp);
				sft = 0x80;
				for (i = 0;i < 8;i ++) {
					if ( (c & sft) != 0) {
						pixel[x+i][y] |= col;
					}
					sft /= 2;
				}
			}
		}
	}


/* Fϊ */
	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x ++) {
			switch (pixel[x][y]) {
				case 0x08:	/*  */
					pixel[x][y] = 0x08;	/*  */
					break;
				case 0x09:	/*  */
					pixel[x][y] = 0x09;	/*  */
					break;
				case 0x0a:	/*  */
					pixel[x][y] = 0x0a;	/*  */
					break;
				case 0x0b:	/*  */
					if ((x+y)%2!= 0) {
						pixel[x][y] = 0x0a;	/*  */
						break;
					} else {
						pixel[x][y] = 0x08;	/*  */
						break;
					}
				case 0x0c:	/*  */
					if ((x+y)%2!= 0) {
						pixel[x][y] = 0x09;	/*  */
						break;
					} else {
						pixel[x][y] = 0x0f;	/*  */
						break;
					}
				case 0x0d:	/* F */
					if ((x+y)%2!= 0) {
						pixel[x][y] = 0x0a;	/*  */
						break;
					} else {
						pixel[x][y] = 0x09;	/*  */
						break;
					}
				case 0x0e:	/*  */
					if ((x+y)%2!= 0) {
						pixel[x][y] = 0x0a;	/*  */
						break;
					} else {
						pixel[x][y] = 0x0f;	/*  */
						break;
					}
				case 0x0f:	/*  */
					pixel[x][y] = 0x0f;	/*  */
					break;

				default:
					pixel[x][y] = 0x07;	/* D */
					break;
			}
		}
	}

/* f[^o͂ */
	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x += 8) {
			a0 = 0;
			a1 = 0;
			for (i = 0;i < 8;i ++) {
				a0 *= 2;
				a1 *= 2;
				if ( (pixel[x+i][y] & 0x01) != 0) {
					a0 ++;
				}
				if ( (pixel[x+i][y] & 0x02) != 0) {
					a1 ++;
				}
			}
			fputc(a0,outfp);
			fputc(a1,outfp);
		}
	}

	for (y = 0;y < height;y ++) {
		for (x = 0;x < width;x += 8) {
			fputc(0x00,outfp);
		}
	}

	while ( (c = fgetc(infp)) != EOF) {
		fputc(c,outfp);
	}

	fclose(outfp);

	fclose(infp);

	return(0);
}

